# swagger-petstore-okhttp-gson

Swagger Petstore
- API version: 1.0.0

This spec is mainly for testing Petstore server and contains fake endpoints, models. Please do not use this for any other purpose. Special characters: \" \\


*Automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen)*


## Requirements

Building the API client library requires:
1. Java 1.7+
2. Maven/Gradle

## Installation

To install the API client library to your local Maven repository, simply execute:

```shell
mvn clean install
```

To deploy it to a remote Maven repository instead, configure the settings of the repository and execute:

```shell
mvn clean deploy
```

Refer to the [OSSRH Guide](http://central.sonatype.org/pages/ossrh-guide.html) for more information.

### Maven users

Add this dependency to your project's POM:

```xml
<dependency>
  <groupId>io.swagger</groupId>
  <artifactId>swagger-petstore-okhttp-gson</artifactId>
  <version>1.0.0</version>
  <scope>compile</scope>
</dependency>
```

### Gradle users

Add this dependency to your project's build file:

```groovy
compile "io.swagger:swagger-petstore-okhttp-gson:1.0.0"
```

### Others

At first generate the JAR by executing:

```shell
mvn clean package
```

Then manually install the following JARs:

* `target/swagger-petstore-okhttp-gson-1.0.0.jar`
* `target/lib/*.jar`

## Getting Started

Please follow the [installation](#installation) instruction and execute the following Java code:

```java
import io.swagger.client.*;
import io.swagger.client.auth.*;
import io.swagger.client.model.*;
import io.swagger.client.api.AnimalApi;

import java.io.File;
import java.util.*;

public class AnimalApiExample {

    public static void main(String[] args) {
        
        AnimalApi apiInstance = new AnimalApi();
        Animal body = new Animal(); // Animal | Animal object that needs to be added to the store
        try {
            apiInstance.addAnimal(body);
        } catch (ApiException e) {
            System.err.println("Exception when calling AnimalApi#addAnimal");
            e.printStackTrace();
        }
    }
}
import io.swagger.client.*;
import io.swagger.client.auth.*;
import io.swagger.client.model.*;
import io.swagger.client.api.AnimalApi;

import java.io.File;
import java.util.*;

public class AnimalApiExample {

    public static void main(String[] args) {
        
        AnimalApi apiInstance = new AnimalApi();
        Long animalId = 789L; // Long | Animal id to delete
        String apiKey = "apiKey_example"; // String | 
        try {
            apiInstance.deleteAnimal(animalId, apiKey);
        } catch (ApiException e) {
            System.err.println("Exception when calling AnimalApi#deleteAnimal");
            e.printStackTrace();
        }
    }
}
import io.swagger.client.*;
import io.swagger.client.auth.*;
import io.swagger.client.model.*;
import io.swagger.client.api.AnimalApi;

import java.io.File;
import java.util.*;

public class AnimalApiExample {

    public static void main(String[] args) {
        
        AnimalApi apiInstance = new AnimalApi();
        Long animalId = 789L; // Long | ID of pet to return
        try {
            Animal result = apiInstance.getAnimalById(animalId);
            System.out.println(result);
        } catch (ApiException e) {
            System.err.println("Exception when calling AnimalApi#getAnimalById");
            e.printStackTrace();
        }
    }
}
import io.swagger.client.*;
import io.swagger.client.auth.*;
import io.swagger.client.model.*;
import io.swagger.client.api.AnimalApi;

import java.io.File;
import java.util.*;

public class AnimalApiExample {

    public static void main(String[] args) {
        
        AnimalApi apiInstance = new AnimalApi();
        Animal body = new Animal(); // Animal | Animal object that needs to be added.
        try {
            apiInstance.updateAnimal(body);
        } catch (ApiException e) {
            System.err.println("Exception when calling AnimalApi#updateAnimal");
            e.printStackTrace();
        }
    }
}
import io.swagger.client.*;
import io.swagger.client.auth.*;
import io.swagger.client.model.*;
import io.swagger.client.api.AnimalApi;

import java.io.File;
import java.util.*;

public class AnimalApiExample {

    public static void main(String[] args) {
        
        AnimalApi apiInstance = new AnimalApi();
        Long animalId = 789L; // Long | ID of animal that needs to be updated
        String name = "name_example"; // String | 
        String status = "status_example"; // String | 
        try {
            apiInstance.updateAnimalWithForm(animalId, name, status);
        } catch (ApiException e) {
            System.err.println("Exception when calling AnimalApi#updateAnimalWithForm");
            e.printStackTrace();
        }
    }
}
```

## Documentation for API Endpoints

All URIs are relative to *http://petstore.swagger.io:80/v2*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*AnimalApi* | [**addAnimal**](docs/AnimalApi.md#addAnimal) | **POST** /animal | Add a new animal to the store
*AnimalApi* | [**deleteAnimal**](docs/AnimalApi.md#deleteAnimal) | **DELETE** /animal/{animalId} | Deletes a animal
*AnimalApi* | [**getAnimalById**](docs/AnimalApi.md#getAnimalById) | **GET** /animal/{animalId} | Find animal by ID
*AnimalApi* | [**updateAnimal**](docs/AnimalApi.md#updateAnimal) | **PUT** /animal | Update an existing animal
*AnimalApi* | [**updateAnimalWithForm**](docs/AnimalApi.md#updateAnimalWithForm) | **POST** /animal/{animalId} | Updates a animal
*AnotherFakeApi* | [**testSpecialTags**](docs/AnotherFakeApi.md#testSpecialTags) | **PATCH** /another-fake/dummy | To test special tags
*DogApi* | [**addDog**](docs/DogApi.md#addDog) | **POST** /dog | Add a new dog to the store
*DogApi* | [**deleteDog**](docs/DogApi.md#deleteDog) | **DELETE** /dog/{dogId} | Deletes a dog
*DogApi* | [**getDogById**](docs/DogApi.md#getDogById) | **GET** /dog/{dogId} | Find dog by ID
*DogApi* | [**updateDog**](docs/DogApi.md#updateDog) | **PUT** /dog | Update an existing dog
*DogApi* | [**updateDogWithForm**](docs/DogApi.md#updateDogWithForm) | **POST** /dog/{dogId} | Updates a dog
*FakeApi* | [**fakeOuterBooleanSerialize**](docs/FakeApi.md#fakeOuterBooleanSerialize) | **POST** /fake/outer/boolean | 
*FakeApi* | [**fakeOuterCompositeSerialize**](docs/FakeApi.md#fakeOuterCompositeSerialize) | **POST** /fake/outer/composite | 
*FakeApi* | [**fakeOuterNumberSerialize**](docs/FakeApi.md#fakeOuterNumberSerialize) | **POST** /fake/outer/number | 
*FakeApi* | [**fakeOuterStringSerialize**](docs/FakeApi.md#fakeOuterStringSerialize) | **POST** /fake/outer/string | 
*FakeApi* | [**testClientModel**](docs/FakeApi.md#testClientModel) | **PATCH** /fake | To test \&quot;client\&quot; model
*FakeApi* | [**testEndpointParameters**](docs/FakeApi.md#testEndpointParameters) | **POST** /fake | Fake endpoint for testing various parameters 假端點 偽のエンドポイント 가짜 엔드 포인트 
*FakeApi* | [**testEnumParameters**](docs/FakeApi.md#testEnumParameters) | **GET** /fake | To test enum parameters
*FakeApi* | [**testEnumRequestBody**](docs/FakeApi.md#testEnumRequestBody) | **POST** /fake/enum/form | To test enum parameters
*FakeApi* | [**testInlineAdditionalProperties**](docs/FakeApi.md#testInlineAdditionalProperties) | **POST** /fake/inline-additionalProperties | test inline additionalProperties
*FakeApi* | [**testJsonFormData**](docs/FakeApi.md#testJsonFormData) | **POST** /fake/jsonFormData | test json serialization of form data
*FakeClassnameTags123Api* | [**testClassname**](docs/FakeClassnameTags123Api.md#testClassname) | **PATCH** /fake_classname_test | To test class name in snake case
*PetApi* | [**addPet**](docs/PetApi.md#addPet) | **POST** /pet | Add a new pet to the store
*PetApi* | [**deletePet**](docs/PetApi.md#deletePet) | **DELETE** /pet/{petId} | Deletes a pet
*PetApi* | [**doCategoryStuff**](docs/PetApi.md#doCategoryStuff) | **POST** /pet/category | 
*PetApi* | [**findPetsByStatus**](docs/PetApi.md#findPetsByStatus) | **GET** /pet/findByStatus | Finds Pets by status
*PetApi* | [**findPetsByTags**](docs/PetApi.md#findPetsByTags) | **GET** /pet/findByTags | Finds Pets by tags
*PetApi* | [**getAllPets**](docs/PetApi.md#getAllPets) | **GET** /allPets | 
*PetApi* | [**getPetById**](docs/PetApi.md#getPetById) | **GET** /pet/{petId} | Find pet by ID
*PetApi* | [**getRandomPet**](docs/PetApi.md#getRandomPet) | **GET** /randomPet | 
*PetApi* | [**updatePet**](docs/PetApi.md#updatePet) | **PUT** /pet | Update an existing pet
*PetApi* | [**updatePetWithForm**](docs/PetApi.md#updatePetWithForm) | **POST** /pet/{petId} | Updates a pet in the store with form data
*PetApi* | [**uploadFile**](docs/PetApi.md#uploadFile) | **POST** /pet/{petId}/uploadImage | uploads an image
*StoreApi* | [**deleteOrder**](docs/StoreApi.md#deleteOrder) | **DELETE** /store/order/{order_id} | Delete purchase order by ID
*StoreApi* | [**getInventory**](docs/StoreApi.md#getInventory) | **GET** /store/inventory | Returns pet inventories by status
*StoreApi* | [**getOrderById**](docs/StoreApi.md#getOrderById) | **GET** /store/order/{order_id} | Find purchase order by ID
*StoreApi* | [**placeOrder**](docs/StoreApi.md#placeOrder) | **POST** /store/order | Place an order for a pet
*UserApi* | [**createUser**](docs/UserApi.md#createUser) | **POST** /user | Create user
*UserApi* | [**createUsersWithArrayInput**](docs/UserApi.md#createUsersWithArrayInput) | **POST** /user/createWithArray | Creates list of users with given input array
*UserApi* | [**createUsersWithListInput**](docs/UserApi.md#createUsersWithListInput) | **POST** /user/createWithList | Creates list of users with given input array
*UserApi* | [**deleteUser**](docs/UserApi.md#deleteUser) | **DELETE** /user/{username} | Delete user
*UserApi* | [**getUserByName**](docs/UserApi.md#getUserByName) | **GET** /user/{username} | Get user by user name
*UserApi* | [**loginUser**](docs/UserApi.md#loginUser) | **GET** /user/login | Logs user into the system
*UserApi* | [**logoutUser**](docs/UserApi.md#logoutUser) | **GET** /user/logout | Logs out current logged in user session
*UserApi* | [**updateUser**](docs/UserApi.md#updateUser) | **PUT** /user/{username} | Updated user

## Documentation for Models

 - [AdditionalPropertiesClass](docs/AdditionalPropertiesClass.md)
 - [AllOfSubCategoryCategory](docs/AllOfSubCategoryCategory.md)
 - [AllOfSubCategoryPetsItems](docs/AllOfSubCategoryPetsItems.md)
 - [AllPetsResponse](docs/AllPetsResponse.md)
 - [Animal](docs/Animal.md)
 - [AnimalFarm](docs/AnimalFarm.md)
 - [ArrayOfArrayOfNumberOnly](docs/ArrayOfArrayOfNumberOnly.md)
 - [ArrayOfNumberOnly](docs/ArrayOfNumberOnly.md)
 - [ArrayTest](docs/ArrayTest.md)
 - [Body](docs/Body.md)
 - [Body1](docs/Body1.md)
 - [Body2](docs/Body2.md)
 - [Body3](docs/Body3.md)
 - [Body4](docs/Body4.md)
 - [Body5](docs/Body5.md)
 - [Body6](docs/Body6.md)
 - [Body7](docs/Body7.md)
 - [Capitalization](docs/Capitalization.md)
 - [Cat](docs/Cat.md)
 - [Category](docs/Category.md)
 - [ClassModel](docs/ClassModel.md)
 - [Client](docs/Client.md)
 - [Dog](docs/Dog.md)
 - [EnumArrays](docs/EnumArrays.md)
 - [EnumClass](docs/EnumClass.md)
 - [EnumTest](docs/EnumTest.md)
 - [FormatTest](docs/FormatTest.md)
 - [HasOnlyReadOnly](docs/HasOnlyReadOnly.md)
 - [List](docs/List.md)
 - [MapTest](docs/MapTest.md)
 - [MixedPropertiesAndAdditionalPropertiesClass](docs/MixedPropertiesAndAdditionalPropertiesClass.md)
 - [Model200Response](docs/Model200Response.md)
 - [ModelApiResponse](docs/ModelApiResponse.md)
 - [ModelReturn](docs/ModelReturn.md)
 - [Name](docs/Name.md)
 - [NullableEnumModel](docs/NullableEnumModel.md)
 - [NumberOnly](docs/NumberOnly.md)
 - [OneOfAllPetsResponseItems](docs/OneOfAllPetsResponseItems.md)
 - [OneOfSinglePetResponsePet](docs/OneOfSinglePetResponsePet.md)
 - [Order](docs/Order.md)
 - [OuterComposite](docs/OuterComposite.md)
 - [OuterEnum](docs/OuterEnum.md)
 - [Pet](docs/Pet.md)
 - [ReadOnlyFirst](docs/ReadOnlyFirst.md)
 - [SinglePetResponse](docs/SinglePetResponse.md)
 - [SpecialModelName](docs/SpecialModelName.md)
 - [SubCategory](docs/SubCategory.md)
 - [Tag](docs/Tag.md)
 - [User](docs/User.md)

## Documentation for Authorization

Authentication schemes defined for the API:
### api_key

- **Type**: API key
- **API key parameter name**: api_key
- **Location**: HTTP header

### api_key_query

- **Type**: API key
- **API key parameter name**: api_key_query
- **Location**: URL query string

### http_basic_test

- **Type**: HTTP basic authentication

### petstore_auth

- **Type**: OAuth
- **Flow**: implicit
- **Authorization URL**: http://petstore.swagger.io/api/oauth/dialog
- **Scopes**: 
  - : 


## Recommendation

It's recommended to create an instance of `ApiClient` per thread in a multithreaded environment to avoid any potential issues.

## Author

apiteam@swagger.io
